# MIDI FILE GENERATOR
# Copyright (c) 2005 Emanuel Borsboom.  All rights reserved.
#
# Code for generating MIDI file
#
require 'midilib'
include MIDI

# Channels
Drum_Channel = 10

# Note numbers
#Octave 0
Af0 = 20
A0 = 21
As0 = Bf0 = 22
B0 = 23
C0 = 24
Cs0 = Df0 = 25
D0 = 26
Ds0 = Ef0 = 27
E0 = 28
F0 = 29
Fs0 = Gf0 = 30
G0 = 31
Gs0 = Af1 = 32
#Octave 1
A1 = 33
As1 = Bf1 = 34
B1 = 35
C1 = 36
Cs1 = Df1 = 37
D1 = 38
Ds1 = Ef1 = 39
E1 = 40
F1 = 41
Fs1 = Gf1 = 42
G1 = 43
Gs1 = Af2 = 44
#Octave 2
A2 = 45
As2 = Bf2 = 46
B2 = 47
C2 = 48
Cs2 = Df2 = 49
D2 = 50
Ds2 = Ef2 = 51
E2 = 52
F2 = 53
Fs2 = Gf2 = 54
G2 = 55
Gs2 = Af3 = 56
#Octave 3
A3 = 57
As3 = Bf3 = 58
B3 = 59
C3 = 60
Cs3 = Df3 = 61
D3 = 62
Ds3 = Ef3 = 63
E3 = 64
F3 = 65
Fs3 = Gf3 = 66
G3 = 67
Gs3 = Af4 = 68
#Octave 4
A4 = 69
As4 = Bf4 = 70
B4 = 71
C4 = 72
Cs4 = Df4 = 73
D4 = 74
Ds4 = Ef4 = 75
E4 = 76
F4 = 77
Fs4 = Gf4 = 78
G4 = 79
Gs4 = Af5 = 80
#Octave 5
A5 = 81
As5 = Bf5 = 82
B5 = 83
C5 = 84
Cs5 = Df5 = 85
D5 = 86
Ds5 = Ef5 = 87
E5 = 88
F5 = 89
Fs5 = Gf5 = 90
G5 = 91
Gs5 = Af6 = 92
#Octave 6
A6 = 93
As6 = Bf6 = 94
B6 = 95
C6 = 96
Cs6 = Df6 = 97
D6 = 98
Ds6 = Ef6 = 99
E6 = 100
F6 = 101
Fs6 = Gf6 = 102
G6 = 103
Gs6 = Af7 = 104

# Note lengths
Whole = 'whole'
Half = 'half'
Quarter = 'quarter'
Eighth = 'eighth'
Sixteenth = 'sixteenth'
Thirtysecond = 'thirty second'
Sixtyfourth = 'sixty fourth'
#Dotted
Dotted_Whole = 'dotted whole'
Dotted_Half = 'dotted half'
Dotted_Quarter = 'dotted quarter'
Dotted_Eighth = 'dotted eighth'
Dotted_Sixteenth = 'dotted sixteenth'
Dotted_Thirtysecond = 'dotted thirty second'
Dotted_Sixtyfourth = 'dotted sixty fourth'
#Triplet
Whole_Triplet = 'whole triplet'
Half_Triplet= 'half triplet'
Quarter_Triplet = 'quarter triplet'
Eighth_Triplet = 'eighth triplet'
Sixteenth_Triplet = 'sixteenth triplet'
Thirtysecond_Triplet = 'thirty second triplet'
Sixtyfourth_Triplet = 'sixty fourth triplet'
#Dotted Triplet
Dotted_Whole_Triplet = 'dotted whole triplet'
Dotted_Half_Triplet = 'dotted half triplet'
Dotted_Quarter_Triplet = 'dotted quarter triplet'
Dotted_Eighth_Triplet = 'dotted eighth triplet'
Dotted_Sixteenth_Triplet = 'dotted sixteenth triplet'
Dotted_Thirtysecond_Triplet = 'dotted thirty second triplet'
Dotted_Sixtyfourth_Triplet = 'dotted sixty fourth triplet'

# General MIDI programs
#PIANO                           
Acoustic_Grand = 1
Bright_Acoustic = 2
Electric_Grand = 3
Honky_Tonk = 4
Electric_Piano_1 = 5
Electric_Piano_2 = 6
Harpsichord = 7
Clavinet = 8
#CHROMATIC PERCUSSION
Celesta = 9
Glockenspiel = 10
Music_Box = 11
Vibraphone = 12
Marimba = 13
Xylophone = 14
Tubular_Bells = 15
Dulcimer = 16
#ORGAN                          
Drawbar_Organ = 17
Percussive_Organ = 18
Rock_Organ = 19
Church_Organ = 20
Reed_Organ = 21
Accoridan = 22
Harmonica = 23
Tango_Accordian = 24
#GUITAR
Nylon_String_Guitar = 25
Steel_String_Guitar = 26
Electric_Jazz_Guitar = 27
Electric_Clean_Guitar = 28
Electric_Muted_Guitar = 29
Overdriven_Guitar = 30
Distortion_Guitar = 31
Guitar_Harmonics = 32
#BASS
Acoustic_Bass = 33
Electric_Bass_Finger = 34
Electric_Bass_Pick = 35
Fretless_Bass = 36
Slap_Bass_1 = 37
Slap_Bass_2 = 38
Synth_Bass_1 = 39
Synth_Bass_2 = 40
#SOLO_STRINGS
Violin = 41
Viola = 42
Cello = 43
Contrabass = 44
Tremolo_Strings = 45
Pizzicato_Strings = 46
Orchestral_Strings = 47
Timpani = 48
#ENSEMBLE
String_Ensemble_1 = 49
String_Ensemble_2 = 50
SynthStrings_1 = 51
SynthStrings_2 = 52
Choir_Aahs = 53
Voice_Oohs = 54
Synth_Voice = 55
Orchestra_Hit = 56
#BRASS
Trumpet = 57
Trombone = 58
Tuba = 59
Muted_Trumpet = 60
French_Horn = 61
Brass_Section = 62
SynthBrass_1 = 63
SynthBrass_2 = 64
#REED
Soprano_Sax = 65
Alto_Sax = 66
Tenor_Sax = 67
Baritone_Sax = 68
Oboe = 69
English_Horn = 70
Bassoon = 71
Clarinet = 72
#PIPE
Piccolo = 73
Flute = 74
Recorder = 75
Pan_Flute = 76
Blown_Bottle = 77
Skakuhachi = 78
Whistle = 79
Ocarina = 80
#SYNTH_LEAD
Lead_1= 81
Lead_2 = 82
Lead_3 = 83
Lead_4 = 84
Lead_5 = 85
Lead_6 = 86
Lead_7 = 87
Lead_8 = 88
#SYNTH_PAD
Pad_1 = 89
Pad_2 = 90
Pad_3 = 91
Pad_4 = 92
Pad_5 = 93
Pad_6 = 94
Pad_7 = 95
Pad_8 = 96
 #SYNTH_EFFECTS
FX_1 = 97
FX_2 = 98
FX_3 = 99
FX_4 = 100
FX_5 = 101
FX_6 = 102
FX_7 = 103
FX_8 = 104
#ETHNIC
Sitar = 105
Banjo = 106
Shamisen = 107
Koto = 108
Kalimba = 109
Bagpipe = 110
Fiddle = 111
Shanai = 112
#PERCUSSIVE
Tinkle_Bell = 113
Agogo = 114
Steel_Drums = 115
Woodblock = 116
Taiko_Drum = 117
Melodic_Tom = 118
Synth_Drum = 119
Reverse_Cymbal = 120
#SOUND_EFFECTS
Guitar_Fret_Noise = 121
Breath_Noise = 122
Seashore = 123
Bird_Tweet = 124
Telephone_Ring = 125
Helicopter = 126
Applause = 127
Gunshot = 128

# Drum note numbers
Acoustic_Bass_Drum = 35
Bass_Drum_1 = 36
Side_Stick = 37
Acoustic_Snare = 38
Hand_Clap = 39
Electric_Snare = 40
Low_Floor_Tom = 41
Closed_Hi_Hat = 42
High_Floor_Tom = 43
Pedal_Hi_Hat = 44
Low_Tom = 45
Open_Hi_Hat = 46
Low_Mid_Tom = 47
Hi_Mid_Tom = 48
Crash_Cymbal_1 = 49
High_Tom = 50
Ride_Cymbal_1 = 51
Chinese_Cymbal = 52
Ride_Bell = 53
Tambourine = 54
Splash_Cymbal = 55
Cowbell = 56
Crash_Cymbal_2 = 57
Vibraslap = 58
Ride_Cymbal_2 = 59
Hi_Bongo = 60
Low_Bongo = 61
Mute_Hi_Conga = 62
Open_Hi_Conga = 63
Low_Conga = 64
High_Timbale = 65
Low_Timbale = 66
High_Agogo = 67
Low_Agogo = 68
Cabasa = 69
Maracas = 70
Short_Whistle = 71
Long_Whistle = 72
Short_Guiro = 73
Long_Guiro = 74
Claves = 75
Hi_Wood_Block = 76
Low_Wood_Block = 77
Mute_Cuica = 78
Open_Cuica = 79
Mute_Triangle = 80
Open_Triangle = 81

# note named parameters
Velocity = 'velocity'

# start_track parameters
Channel = 'channel'

# drum parameters
Length = 'length'

class TrackVars
	attr_accessor :time, :channel, :velocity, :dir
	def initialize
		@time = 0
		@channel = 0
		@velocity = 64
		@dir = "."
	end
end

def reset
	$seq = Sequence.new()
	$controlTrack = Track.new($seq)
	$seq.tracks << $controlTrack;
	$songTrack = Track.new($seq)
	$seq.tracks << $songTrack;
	$varStack = []
	$curVars = TrackVars.new
	$orderId = 0
end

class Event
	attr_accessor :order_id
end

def control_event(ev)
	ev.time_from_start = $curVars.time;
	ev.order_id = $orderId
	$orderId += 1
	$controlTrack.events << ev;
end

def event(ev)
	ev.time_from_start = $curVars.time;
	ev.order_id = $orderId
	$orderId += 1
	$songTrack.events << ev;
end

def tempo(bpm)
	control_event Tempo.new(Tempo.bpm_to_mpq(bpm));
end

def channel(chan)
	$curVars.channel = chan - 1
end

def event_channel
	return $curVars.channel
end

def program(prog)
	event ProgramChange.new(event_channel, prog - 1)
end

def volume(vol)
	event Controller.new(event_channel, CC_VOLUME, vol)
end

def start_track(params)
	$varStack.push $curVars
	$curVars = $curVars.dup
	channel params[Channel] if params[Channel]
end

def end_track
	$curVars = $varStack.pop	
end

def velocity(vel)
	$curVars.velocity = vel
end

def chorus(chor)
	event Controller.new(event_channel, CC_CHORUS_DEPTH, chor)	
end

def pan(p)
	event Controller.new(event_channel, CC_PAN, p)	
end

def reverb(rev)
	event Controller.new(event_channel, 91, rev)	
end

def do_note(noteNums, params)
	if !noteNums.instance_of? Array
		noteNums = [noteNums]
	end
	if params[Velocity]
		velocity = params[Velocity]
	else
		velocity = $curVars.velocity
	end
	noteNums.each do |noteNum|
		ev = yield noteNum, velocity
		event ev
	end
end

def note_on(noteNums, params = {})
	do_note(noteNums, params) { |noteNum, velocity| NoteOnEvent.new(event_channel, noteNum, velocity) }
end

def note_off(noteNums, params = {})
	do_note(noteNums, params) { |noteNum, velocity| NoteOffEvent.new(event_channel, noteNum, velocity) }
end

def note(noteNums, length, params = {})
	if (length.class == String)
		length = $seq.note_to_length(length)
	end
	lengthDelta = $seq.length_to_delta(length)
	note_on noteNums, params
	$curVars.time += lengthDelta
	note_off noteNums, params
end

def drum(noteNum, params = {})
	if params[Length]
		note noteNum, params[Length], params
	else
		note noteNum, Quarter, params
		rewind Quarter
	end
end

def rest(length)
	if length.instance_of? String
		length = $seq.note_to_length(length)
	end
	$curVars.time += $seq.length_to_delta(length)	
end

def rewind(length)
	if length.instance_of? String
		length = $seq.note_to_length(length)
	end
	$curVars.time -= $seq.length_to_delta(length)	
end

def time(time)
	$curVars.time = $seq.length_to_delta(time);
end

def load_track(filename, track_params = {})
	full_filename = File.expand_path(filename, $curVars.dir)
	start_track(track_params)
	$curVars.dir = File.dirname(full_filename)
	load(full_filename, true)
	end_track()
end

def save_sequence(filename)
	$controlTrack.sort
	$songTrack.events.sort! do |a, b|
		#ta = a.time_from_start * 3 + 2;
		#if a.instance_of? ProgramChange then ta -= 1 end
		#if a.instance_of? NoteOffEvent then ta -= 2 end
		#tb = b.time_from_start * 3 + 2;
		#if b.instance_of? ProgramChange then tb -= 1 end
		#if b.instance_of? NoteOffEvent then tb -= 2 end
		#ta <=> tb
		#puts "#{a.time_from_start} #{b.time_from_start}"
		if a.time_from_start == b.time_from_start
			a.order_id <=> b.order_id 
		else
			a.time_from_start <=> b.time_from_start
		end
	end
	$songTrack.recalc_delta_from_times()
	
	File.open(filename, 'wb') do |file|
		$seq.write(file)
	end
end
